#pragma once

#include "vertex.hpp"
#include "draw_strategy_base.hpp"
#include <memory>

namespace gz {
    class Rectangle {
        public:
            Rectangle(float top, float left, float width, float height, std::unique_ptr<DrawStrategy<Rectangle>>&& drawStrategy);
			inline const glm::vec2& getPosition() const { return position; }
			inline void setPosition(const glm::vec2& v) { position = v; }
			inline void setPosition(glm::vec2&& v) { position = std::move(v); }
			inline const glm::vec2& getSize() const { return size; }
			inline void setSize(const glm::vec2& v) { size = v; }
			inline void setSize(glm::vec2&& v) { size = std::move(v); }
            void draw() { drawStrategy->draw(); };
            std::string toString() const;
        private:
            void update();
            glm::vec2 position;
            glm::vec2 size;
            std::unique_ptr<DrawStrategy<Rectangle>> drawStrategy;
    };


}  // namespace gz
