#include "ds_vk_base.hpp"

#include "renderer2D.hpp"

namespace gz::vlk {
	void VulkanDS::setIndexOffset(uint32_t offset) {
        for (size_t i = 0; i < indices.size(); i++) {
            indices[i] += offset;
        }
	}


	void VulkanDS::normalizeVertices(float width, float height) {
        for (size_t i = 0; i < vertices.size(); i++) {
            vertices[i].pos.x /= width;
            vertices[i].pos.y /= height;
        }
	}


	void VulkanDS::updateBufferInfos() {
        assert(vertexBufferInfo.index == BUFFER_NOT_INITIALIZED);
        std::tie(vertexBufferInfo, indexBufferInfo) = bufferManager.get().addVertices(vertices, indices);
	}


	VulkanTexturedDS::VulkanTexturedDS(TextureManager& textureManager, Texture texture) 
        : texture(texture), textureAtlasIndex(textureManager.getTextureAtlasIndex(texture)), textureManager(textureManager)
    {

	}


}  // namespace gz::vlk
